/*****************************************************************************
 DOS/32 Advanced Example Files Collection
 Copyright (C) 1996-1998 Supernar Systems, Intl.
 All Rights Reserved.

 MEMORY.C
 This program will show memory availability under DOS/32 Advanced.
 Note that this program is linked in LE format, so you could run it
 under different DOS Extenders.

*****************************************************************************/



struct memory {
	unsigned long LargestFreeBlock;
	unsigned long MaxUnlockedPages;
	unsigned long MaxLockedPages;
	unsigned long LinearSpaceInPages;
	unsigned long TotalNumOfUnlockedPages;
	unsigned long TotalNumOfFreePages;
	unsigned long TotalNumOfPhysPages;
	unsigned long FreeLinearSpaceInPages;
	unsigned long SizeOfPagingFile;
	unsigned long Reserved[3];
} Mem;

#pragma aux getmeminfo =		\
	"mov	eax,0500h"		\
	"mov	edi,offset Mem"		\
	"int	31h"			\
	modify [eax edi];



void main(int argc, char *argv[]) {

	getmeminfo();

	printf("\n");
	printf("DPMI Memory Information:\n");
	printf("-----------------------------------------------------------------\n");

	printf("Largest Available Free Block Size:   ");
		printf("0x%08X (%9d) bytes",
		Mem.LargestFreeBlock,
		Mem.LargestFreeBlock);
	printf("\n");

	printf("Maximum Unlocked Page Allocations:   ");
	if(Mem.MaxUnlockedPages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.MaxUnlockedPages,
		Mem.MaxUnlockedPages);
	else printf("information not available");
	printf("\n");

	printf("Maximum Locked Page Allocations:     ");
	if(Mem.MaxLockedPages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.MaxLockedPages,
		Mem.MaxLockedPages);
	else printf("information not available");
	printf("\n");

	printf("Linear Address Space Size:           ");
	if(Mem.LinearSpaceInPages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.LinearSpaceInPages,
		Mem.LinearSpaceInPages);
	else printf("information not available");
	printf("\n");

	printf("Total Number of Unlocked Pages:      ");
	if(Mem.TotalNumOfUnlockedPages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.TotalNumOfUnlockedPages,
		Mem.TotalNumOfUnlockedPages);
	else printf("information not available");
	printf("\n");

	printf("Total Number of Free Pages:          ");
	if(Mem.TotalNumOfFreePages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.TotalNumOfFreePages,
		Mem.TotalNumOfFreePages);
	else printf("information not available");
	printf("\n");

	printf("Total Number of Physical Pages:      ");
	if(Mem.TotalNumOfPhysPages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.TotalNumOfPhysPages,
		Mem.TotalNumOfPhysPages);
	else printf("information not available");
	printf("\n");

	printf("Free Linear Address Space:           ");
	if(Mem.FreeLinearSpaceInPages!=-1)
		printf("0x%08X (%9d) pages",
		Mem.FreeLinearSpaceInPages,
		Mem.FreeLinearSpaceInPages);
	else printf("information not available");
	printf("\n");

	printf("Size of Paging File/Partition:       ");
	if(Mem.SizeOfPagingFile!=-1)
		printf("0x%08X (%9d) pages",
		Mem.SizeOfPagingFile,
		Mem.SizeOfPagingFile);
	else printf("information not available");
	printf("\n");


	exit(0);
}
