/*****************************************************************************
 DOS/32 Advanced Example Files Collection
 Copyright (C) 1996-1998 Supernar Systems, Intl.
 All Rights Reserved.

 EXCEPT86.C
 This program will show how the exceptions are handled under DOS/32 Advanced.
 Note that if an external DPMI host is present, for example when running
 under Windows or OS/2, it will be responsible for the handling of the
 exception.

*****************************************************************************/


#pragma aux except86 =	\
	"mov	cs:[0080h],al";

#pragma aux cls = \
	"mov	ax,03h"	\
	"int	10h"	\
	modify [eax];

#pragma aux getkey =	\
	"xor	ax,ax"	\
	"int	16h"	\
	modify [eax];

#pragma aux except86chk =	\
	"mov	ax,0FF8Ah"	\
	"int	21h"		\
	"cmp	eax,'ID32'"	\
	"mov	eax,3"		\
	"jnz	@@done"		\
	"cmp	ch,3"		\
	"mov	eax,2"		\
	"jz	@@done"		\
	"test	dl,02h"		\
	"mov	eax,1"		\
	"jz	@@done"		\
	"mov	eax,0"		\
"@@done:"			\
	modify [eax ebx ecx edx esi]\
	value [eax];





void main() {

	cls();

	printf("\
	==========================================================\n\
	 This program  will  generate  an exception #13,  General \n\
	 Protection Fault,  just to show you how  DOS/32 Advanced \n\
	 traps down run-time errors and reports them to the user, \n\
	 and how you can  debug an application  that generates an \n\
	 exception.                                               \n\
\n\
	 To debug an application that contains error,  use SUNSYS \n\
	 Debugger.  Note the unrelocated address,  and  start the \n\
	 Debugger by typing  SD <filename.exe> at DOS prompt. Now \n\
	 press the  ENTER  key and enter  the unrelocated address \n\
	 you memorized preceeded by a  <.>  (point). The Debugger \n\
	 will now show the faulting instruction under the cursor. \n\
\n\
	 You may  also want  to instruct  the linker  to generate \n\
	 a map file.  By looking at  map file  and compairing the \n\
	 unrelocated addresses you may gain the information about \n\
	 where,  in which module  and  which subroutine  in  your \n\
	 application the exception is thrown.                     \n\
	==========================================================\n\n");

	printf("Now the exception #13 will be generated.\n");
	printf("Press any key to continue...\n");
	getkey();
	printf("\n");

	switch(except86chk()) {
		case 0:	except86();
			break;

		case 1:	printf("Internal Exception Control is not active!!!\n\n");
			printf("Use the SUNSYS Setup Utility Program to turn on the Internal\n");
			printf("Exception Control.\n");
			break;

		case 2: printf("Cannot generate exception under external DPMI host!!!\n\n");
			printf("DOS/32 Advanced DOS Extender does not handle exceptions when\n");
			printf("running under an external DPMI host. You need to exit any\n");
			printf("multitasking programs (such as Windows or OS/2) in order to\n");
			printf("run this test program successfully.\n");
			break;

		case 3:	printf("DOS/32 Advanced DOS Extender not present!!!\n\n");
			printf("You should not run this test program under other DOS Extenders\n");
			printf("than DOS/32 Advanced.\n");
			break;
	}

	exit(0);
}
