/*****************************************************************************
 DOS/32 Advanced Example Files Collection
 Copyright (C) 1996-1998 Supernar Systems, Intl.
 All Rights Reserved.

 SPAWN.C
 This example program will show how to spawn an application under DOS/32A.

 The SPAWN.EXE program will run PROG1.EXE which in its turn will run PROG2.EXE
 Each program will report the amount of available extended memory (in pages)
 and return codes.

*****************************************************************************/
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <process.h>


	unsigned char CpuType;
	unsigned char SysType;

struct memory {
	unsigned long LargestFreeBlock;
	unsigned long MaxUnlockedPages;
	unsigned long MaxLockedPages;
	unsigned long LinearSpaceInPages;
	unsigned long TotalNumOfUnlockedPages;
	unsigned long TotalNumOfFreePages;
	unsigned long TotalNumOfPhysPages;
	unsigned long FreeLinearSpaceInPages;
	unsigned long SizeOfPagingFile;
	unsigned long Reserved[3];
} Mem;




#pragma aux getmem =			\
	"mov	eax,0500h"		\
	"mov	edi,offset Mem"		\
	"int	31h"			\
	modify [eax edi];

#pragma aux getinfo =			\
	"push	fs"			\
	"mov	eax,0FF8Ah"		\
	"int	21h"			\
	"mov	CpuType,cl"		\
	"mov	SysType,ch"		\
	"pop	fs"			\
	modify [eax ebx ecx edx esi];




void main() {
	int n,i;
	clock_t exec_start, exec_end;
	const char *args[] = { "prog1.exe", 0 };	// command line

	getmem();
	getinfo();
	printf("\n");
	printf("SPAWN:  SYS=%02Xh, MEM=%08Xh\n",
		SysType, Mem.FreeLinearSpaceInPages);

	putenv("DOS32A=QUIET");

	exec_start=clock();
	for(i=0; i<3; i++) n=spawnvp(P_WAIT, "prog1.exe", args);
	exec_end=clock();

	getmem();
	printf("SPAWN: RET=%02Xh, MEM=%08Xh\n",
		n, Mem.FreeLinearSpaceInPages);
	printf("\n");

	printf("Execution time was: %d timer ticks\n",
		exec_end-exec_start);

	exit(0);
}
